"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _constants = require("istanbul-lib-instrument/src/constants");
const http = require('http');
const url = require('url');
const {
  createHash
} = require('crypto');
var _default = (targetUrl, coverageData, baseAST) => {
  coverageData[_constants.MAGIC_KEY] = _constants.MAGIC_VALUE;
  const hash = createHash(_constants.SHA).update(JSON.stringify(coverageData)).digest('hex');
  coverageData.hash = hash;
  coverageData.AST = JSON.parse(baseAST);
  const postData = JSON.stringify(coverageData);
  delete coverageData[_constants.MAGIC_KEY];
  delete coverageData.hash;
  delete coverageData.AST;
  const parsedUrl = url.parse(targetUrl);
  const options = {
    hostname: parsedUrl.hostname,
    port: parsedUrl.port || 80,
    path: parsedUrl.path,
    method: 'POST',
    timeout: 20000,
    headers: {
      'Content-Type': 'application/json',
      'Content-Length': Buffer.byteLength(postData)
    }
  };
  const req = http.request(options, res => {
    if (res.statusCode != 200) {
      console.log(`STATUS: ${res.statusCode}`);
      res.setEncoding('utf8');
      res.on('data', chunk => {
        console.log(`BODY: ${chunk}`);
      });
    }
  });
  req.on('error', e => {
    console.error(`problem with request: ${e.message}`);
  });

  // write data to request body
  req.write(postData);
  req.end();
};
exports.default = _default;